---------
---AFAC--
---------
-- Modded from: DES-010 - Designation of AREAS - Threat Level Prioritization
-- Original author: FlightControl
--
-- Recce unit(s) will detect, prioritize and designate enemy units, which are grouped in AREAs.
-- First the SAMs should be designated, then the rest. Use the "Other" comms menu to select autolase, smoke or illumination 
-- Laser code set is 1688, this can be changed in the script. Laser will turn off 120 seconds after it is selected on
-- 
-- In ME:
-- create one or more aircraft, MQ-9 Reaper or MQ-1A Predator "RECCE X" group, make pilot name the same as group name
-- task reconnaissance
-- uncheck radio
-- waypoint type "turning" , set altitude 21,000 AGL to avoid low level SAM threat
-- speed 150, add 2 waypoints
--
-- advanced waypoint actions--
-- Perform task at waypoint 1: Orbit, racetrack, 21000
--
-- create a "HQ" vehicle group, category unarmed, CP Predator GCS


RecceSetGroup = SET_GROUP:New():FilterPrefixes( "Blue RECCE" ):FilterStart()

-- Set up the HQ
HQ = GROUP:FindByName( "Blue drone HQ" )
CC = COMMANDCENTER:New( HQ, "Blue drone HQ" )

-- Let the RecceSetGroup vehicles in the collection detect targets and group them in AREAS of 1000 meters.
RecceDetection = DETECTION_AREAS:New( RecceSetGroup, 5000 )

-- Create a Attack Set, which contains the human player client slots and CA vehicles.
AttackSet = SET_GROUP:New():FilterCoalitions("blue"):FilterStart()

RecceDesignation = DESIGNATE:New( CC, RecceDetection, AttackSet )

-- This sets the threat level prioritization on
RecceDesignation:SetThreatLevelPrioritization( true )

-- Sets the maximum designations. The default is 5 designations.
RecceDesignation:SetMaximumDesignations( 1 )

-- Set the maximum amount of markings FACs will do, per designated target group.
RecceDesignation:SetMaximumMarkings( 1 )

-- This sets autolase in seconds
RecceDesignation:SetLaseDuration( 1800 )

-- Set the laser code
RecceDesignation:SetLaserCodes( 1688 )

-- Start the detection process in 5 seconds.
RecceDesignation:__Detect( -5 )

