------------------------
-- Squadron and Wings --
------------------------

-- modified from @pikes script

-- Common zones
local Zone={}
Zone.Alpha   = ZONE:New("Zone Alpha")   --Core.Zone#ZONE --Heli CAS zone
Zone.Bravo   = ZONE:New("Zone Bravo")   --Core.Zone#ZONE --CAP and Aircraft CAS zone
-- Zone.Charlie = ZONE:New("Zone Charlie") --Core.Zone#ZONE --not used
-- Zone.Delta   = ZONE:New("Zone Delta")   --Core.Zone#ZONE --not used
-- Set of all zones defined in the ME
local AllZones=SET_ZONE:New():FilterOnce()

-- CREATE SQUADRONS
-- SQUADRON:New(TemplateGroupName, Ngroups, SquadronName)
-- Set livery painted on all squadron aircraft.
-- Note that the livery name in general is different from the name shown in the mission editor.
-- Valid names are the names of the **livery directories**. Check out the folder in your DCS installation for:
-- * Full modules: `DCS World OpenBeta\CoreMods\aircraft\<Aircraft Type>\Liveries\<Aircraft Type>\<Livery Name>`
-- * AI units: `DCS World OpenBeta\Bazar\Liveries\<Aircraft Type>\<Livery Name>`
-- 
-- The folder name `<Livery Name>` is the string you want.

--AV8B squadron
squadronA=SQUADRON:New("VMA-214", 4, "VMA-214") --Ops.Squadron#SQUADRON
 squadronA:SetCallsign(CALLSIGN.Aircraft.Dodge)
 squadronA:SetRadio(305)
 squadronA:SetLivery("VMA-214")
 squadronA:SetSkill(AI.Skill.EXCELLENT)
-- squadronA:SetTurnoverTime(15*60, 0) -- SetTurnoverTime(MaintenanceTime, RepairTime)
 squadronA:SetFuelLowThreshold(60)
 squadronA:SetGrouping(1)
 squadronA:SetModex(77, nil, nil)
 squadronA:SetVerbosity(2) 
 squadronA:AddMissionCapability({AUFTRAG.Type.BAI,AUFTRAG.Type.CAS}, 100)
 
--F18 squadron
squadronB=SQUADRON:New("VFA-87", 4, "VFA-87") --Ops.Squadron#SQUADRON 
 squadronB:SetCallsign(CALLSIGN.Aircraft.Pontiac)
 squadronB:SetRadio(305)
 squadronB:SetLivery("VFA-87")
 squadronB:SetSkill(AI.Skill.EXCELLENT)
 squadronB:SetFuelLowThreshold(50)
 squadronB:SetGrouping(1)
 squadronB:SetModex(87, nil, nil)
 squadronB:SetVerbosity(2) 
 squadronB:AddMissionCapability({AUFTRAG.Type.SEAD, AUFTRAG.Type.CAS, AUFTRAG.Type.CAP}, 100) --AUFTRAG.Type.FACA AUFTRAG.Type.CAS AUFTRAG.Type.BOMBING

--A10C2 squadron
squadronC=SQUADRON:New("74th FS", 4, "74th FS") --Ops.Squadron#SQUADRON 
 squadronC:SetCallsign(CALLSIGN.Aircraft.Colt)
 squadronC:SetRadio(305)
 squadronC:SetLivery("74th FS Moody AFB, Georgia (FT)")
 squadronC:SetSkill(AI.Skill.EXCELLENT)
 squadronC:SetFuelLowThreshold(50)
 squadronC:SetGrouping(1)
 squadronC:SetModex(61, nil, nil)
 squadronC:SetVerbosity(2) 
 squadronC:AddMissionCapability({AUFTRAG.Type.BAI, AUFTRAG.Type.CAS}, 100) --AUFTRAG.Type.FACA AUFTRAG.Type.CAS AUFTRAG.Type.BOMBING AUFTRAG.Type.INTERCEPT, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.STRIKE
 
--AH-64D squadron
squadronD=SQUADRON:New("3 Regt AAC", 4, "3 Regt AAC") --Ops.Squadron#SQUADRON 
 squadronD:SetCallsign(CALLSIGN.Aircraft.Uzi)
 squadronD:SetRadio(305)
 squadronD:SetLivery("ah-64_d_green uk")
 squadronD:SetSkill(AI.Skill.EXCELLENT)
 squadronD:SetFuelLowThreshold(50)
 squadronD:SetGrouping(1)
 squadronD:SetModex(98, nil, nil)
 squadronD:SetVerbosity(2) 
 squadronD:AddMissionCapability({AUFTRAG.Type.BAI, AUFTRAG.Type.CAS}, 100) --AUFTRAG.Type.FACA AUFTRAG.Type.CAS AUFTRAG.Type.BOMBING AUFTRAG.Type.INTERCEPT, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.STRIKE
 
--F-16 squadron
squadronE=SQUADRON:New("Polish 31 AF", 4, "Polish 31 AF") --Ops.Squadron#SQUADRON 
 squadronE:SetCallsign(CALLSIGN.Aircraft.Chevy)
 squadronE:SetRadio(305)
 squadronE:SetLivery("Polish 6th sqn 4063")
 squadronE:SetSkill(AI.Skill.EXCELLENT)
 squadronE:SetFuelLowThreshold(50)
 squadronE:SetGrouping(1)
 squadronE:SetModex(32, nil, nil)
 squadronE:SetVerbosity(2) 
 squadronE:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.BAI, AUFTRAG.Type.CAS}, 100) --AUFTRAG.Type.FACA AUFTRAG.Type.CAS AUFTRAG.Type.BOMBING AUFTRAG.Type.INTERCEPT, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.STRIKE

-- Create AIRWINGS - note these are warehouses and in the case of ships, the ship name
-- @param #string warehousename Name of the warehouse static or unit object representing the warehouse.
-- @param #string airwingname Name of the air wing, e.g. "AIRWING-8".
-- function AIRWING:New(warehousename, airwingname)

hangarA=AIRWING:New("Hangar AV8B", "Hangar AV8B") --Ops.AirWing#AIRWING
hangarB=AIRWING:New("Hangar F18", "Hangar F18") 
hangarC=AIRWING:New("Hangar A10C2", "Hangar A10C2")
hangarD=AIRWING:New("Hangar AH64D", "Hangar AH64D")
hangarE=AIRWING:New("Hangar F16", "Hangar F16")
 
-- Add squadrons to airwing.
hangarA:AddSquadron(squadronA)
hangarB:AddSquadron(squadronB)
hangarC:AddSquadron(squadronC)
hangarD:AddSquadron(squadronD)
hangarE:AddSquadron(squadronE)

-- PAYLOADS (multiples can be made)
-- In Mission Editor: select late activation
-- @param Wrapper.Unit#UNIT Unit The unit, the payload is extracted from. Can also be given as *#string* name of the unit.
-- @param #number Npayloads Number of payloads to add to the airwing resources. Default 99 (which should be enough for most scenarios). Set to -1 for unlimited.
-- @param #table MissionTypes Mission types this payload can be used for.
-- @param #number Performance A number between 0 (worst) and 100 (best) to describe the performance of the loadout for the given mission types. Default is 50.
-- @return #AIRWING.Payload The payload table or nil if the unit does not exist.
-- function AIRWING:NewPayload(Unit, Npayloads, MissionTypes,  Performance)

local AV8BCAS=hangarA:NewPayload(GROUP:FindByName("VMA-214 CAS"), 20, {AUFTRAG.Type.CAS}, 100)
local AV8BBAI=hangarA:NewPayload(GROUP:FindByName("VMA-214 BAI"), 20, {AUFTRAG.Type.CAS}, 100)
local F18SEAD=hangarB:NewPayload(GROUP:FindByName("VFA-87 SEAD"), 20, {AUFTRAG.Type.SEAD}, 100)
local F18CAS=hangarB:NewPayload(GROUP:FindByName("VFA-87 CAS"), 20, {AUFTRAG.Type.BAI,AUFTRAG.Type.CAS}, 100)
local F18CAP=hangarB:NewPayload(GROUP:FindByName("VFA-87 CAP"), 20, {AUFTRAG.Type.CAP}, 100)
local A10C2CAS=hangarC:NewPayload(GROUP:FindByName("74th FS CAS"), 20, {AUFTRAG.Type.CAS}, 100)
local A10C2BAI=hangarC:NewPayload(GROUP:FindByName("74th FS BAI"), 20, {AUFTRAG.Type.BAI}, 100)
local AH64DCAS=hangarD:NewPayload(GROUP:FindByName("3 Regt AAC CAS"), 20, {AUFTRAG.Type.BAI,AUFTRAG.Type.CAS}, 100)
local F16CAP=hangarE:NewPayload(GROUP:FindByName("Polish 31 AF CAP"), 20, {AUFTRAG.Type.CAP}, 100)
local F16CAS=hangarE:NewPayload(GROUP:FindByName("Polish 31 AF CAS"), 20, {AUFTRAG.Type.CAS}, 100)
local F16BAI=hangarE:NewPayload(GROUP:FindByName("Polish 31 AF BAI"), 20, {AUFTRAG.Type.BAI}, 100)

-- Start the Airwings
hangarA:Start()
hangarB:Start()
hangarC:Start()
hangarD:Start()
hangarE:Start()

-- SETUP an aircraft to do armed reconnaisance of the area
local auftrag = AUFTRAG:NewCAS(Zone.Bravo, 15000, 350, nil, nil, nil, "IR Guided SAM" )
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetRepeatOnFailure(5) 
auftrag:SetTime( 20 , 20*60 )
hangarA:AddMission(auftrag)

-- Create a SET of all Blue Groups
local AgentSet=SET_GROUP:New():FilterCoalitions("blue"):FilterStart()

-- Declare an INTEL based off that SET, for BLUE coalition
local cia=INTEL:New(AgentSet, coalition.side.BLUE)  
cia:AddAcceptZone(ZONE_POLYGON:NewFromGroupName("Blue Ops Area")) --give it an inclusive area  
cia:Start() --start it

-- THIS IS A CUSTOM FUNCTION TO CREATE A MISSION FOR ALL DETECTIONS OF THE RIGHT TYPE
function ATO(contact) 

if (contact.attribute == "Ground_SAM") or (contact.attribute == "Ground_AAA") or (contact.attribute == "Ground_EWR") then

	local target=GROUP:FindByName(contact.groupname)
    local auftrag=AUFTRAG:NewSEAD(target, 21000)
	auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
	auftrag:SetRepeatOnFailure(4)
	auftrag:SetTime( 20 , 25*60 )
    hangarB:AddMission(auftrag)
	
	elseif contact.attribute == "Ground_Artillery" then

    local target=GROUP:FindByName(contact.groupname)
    local auftrag=AUFTRAG:NewBAI(target, 21000)
	auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
	auftrag:SetRepeatOnFailure(4)
	auftrag:SetTime( 120 , 45*60 )
    auftrag:SetMissionAltitude(11000)
    hangarC:AddMission(auftrag)
	
	elseif contact.attribute == "Air_AttackHelo" then
	
	local auftrag = AUFTRAG:NewCAP(Zone.Bravo, 22000, 350, nil, nil, nil, nil)
	auftrag:SetTime( 80 , 45*60 )
	auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
	auftrag:SetRepeatOnFailure(4) 
	hangarE:AddMission(auftrag)	
		
	end

end

--- Function called when a NEW contact is detected.
function cia:OnAfterNewContact(From, Event, To, Contact)
  local contact=Contact --Ops.Intelligence#INTEL.Contact
  ATO(contact) --fire the function for the contact  
end --end OnAfterNew


----set up the menu using these flights
-- https://wiki.hoggitworld.com/view/DCS_enum_attributes for target attributes

function av8bcas()
MESSAGE:New("AV8B CAS request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAS(Zone.Bravo, 16000, 350, nil, nil, nil, nil )
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE) 
auftrag:SetTime( 5 , 20*60 )
hangarA:AddMission(auftrag)
end

function f18cas()
MESSAGE:New("F18 CAS request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAS(Zone.Bravo, 15000, 350, nil, nil, nil, nil )
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetTime( 5 , 25*60 )
hangarB:AddMission(auftrag)
end

function a10c2cas()
MESSAGE:New("A10C2 CAS request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAS(Zone.Bravo, 15000, 350, nil, nil, nil, nil )
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetTime( 5 , 35*60 )
hangarC:AddMission(auftrag)
end

function f16cas()
MESSAGE:New("F16 CAS request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAS(Zone.Bravo, 16000, 350, nil, nil, nil, nil )
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetTime( 5 , 25*60 )
hangarE:AddMission(auftrag)
end

function ah64dcas()
MESSAGE:New("AH64D CAS request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAS(Zone.Alpha, 2000, 150, nil, nil, nil, nil )
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetTime( 5 , 25*60 )
hangarD:AddMission(auftrag)
end

function f18cap()
MESSAGE:New("F18 CAP request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAP(Zone.Bravo, 22000, 350, nil, nil, nil, nil)
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetTime( 5 , 45*60 )
hangarB:AddMission(auftrag)
end

function f16cap()
MESSAGE:New("F16 CAP request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAP(Zone.Bravo, 21000, 350, nil, nil, nil, nil)
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.TWO)
auftrag:SetTime( 5 , 35*60 )
hangarE:AddMission(auftrag)
end


-- --TOP MENU
TopMenu1 = MENU_MISSION:New( "Aircraft tasking request" )

-- --FIRST SUB MENU
Menu1 = MENU_MISSION_COMMAND:New("Request AV8B CAS", TopMenu1, av8bcas)
Menu2 = MENU_MISSION_COMMAND:New("Request F18 CAS", TopMenu1, f18cas)
Menu3 = MENU_MISSION_COMMAND:New("Request A10C2 CAS", TopMenu1, a10c2cas)
Menu4 = MENU_MISSION_COMMAND:New("Request F16 CAS", TopMenu1, f16cas)
Menu5 = MENU_MISSION_COMMAND:New("Request AH64D CAS", TopMenu1, ah64dcas)
Menu6 = MENU_MISSION_COMMAND:New("Request F18 CAP", TopMenu1, f18cap)
Menu7 = MENU_MISSION_COMMAND:New("Request F16 CAP", TopMenu1, f16cap)






